︠742275ca-04e5-4e7c-b4ef-7f05b3053ec0︠
# Mini project: Comparing convergence of the simple iteration method and the Newton's method
#Consider the function f(x)=exp(-x)*(x^2-5*x-2)+1.
# Plot the function to convince yourself that the function has two roots. For each of the roots use the "find_root" function to obtain high accuracy value of the root1 and root2.
#For each of the roots Do the following
#(a) (challenging!) Convert the root-finding problem for f to a fixed point problem g(x)=x with appropriate function g.
#(b) Choose an initial approximation of the root that guarantees convergence of the simple iteration and make a list L with n=7 iterates using simple iteration.
#(c) Use the same initial guess for solving the root-finding problem by Newton's method. Make a list N with n=7 iterates using Newton's iterations.
#(d) Make a table with 7 rows for x[n]-values, n=0..6, and 3 columns with the table header n, L[n],and N[n]. Compare convergence of these two methods.
︡1eadac08-9ca7-4dde-af48-ef961b0fa360︡
︠10aded45-fddc-4029-b09d-f08d74631415s︠
reset
︡bd0f48ed-1a1f-4495-bd45-6f85a99e4f15︡{"stdout":"<function reset at 0x7f38ea66e0c8>\n"}︡{"done":true}
︠86355c0e-0602-48b5-9464-efb4ba0c479as︠
f(x)=exp(-x)*(x^2-5*x-2)+1
plot(f(x), x,-1, 3, figsize=[4,3])
︡35fe9dc2-e8aa-4e52-aafd-8092f8820638︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/327/tmp_guKTd7.svg","show":true,"text":null,"uuid":"2418852d-4990-464a-bd2e-e8b1714bbbdd"},"once":false}︡{"done":true}
︠4a4d22cb-68d7-423c-8776-201a8f6a64c0s︠
root1=find_root(f(x),-1, 0);root1
︡2e3d8869-1ebc-4e1d-a7d6-80ccf91c31d1︡{"stdout":"-0.23054999321338798"}︡{"stdout":"\n"}︡{"done":true}
︠1be9301c-84f6-42e7-960e-608667dcd58fs︠
root2=find_root(f(x),1,3);root2
︡fc9cd93e-e5f7-4e6f-8ef7-ab017d4135ea︡{"stdout":"2.0895848494844653\n"}︡{"done":true}
︠94307de5-07dc-43ca-ba01-bb055db3ccaes︠
#Version 1
# (a) Solve the equation f(x)=0 for x. Hint: there are three options here. Do not solve for x in the exponential function. The other two options will work.
g1(x)=(x^2+exp(x)-2)/5

︡b7339b36-64a5-48e3-a8fc-bedc62556eb5︡{"done":true}
︠0d70e8bf-3792-4c7d-a23a-6cbc8831ec58s︠
line_plot1=plot(x,-1,0)
g1plot=plot(g1,-1,3,figsize=[4,3])
g1prime_plot=plot(((2/5)*x+exp(x)/5), -1, 3,color='red')
(g1plot+g1prime_plot+line_plot1).show()
︡a6de6348-5526-4712-a25b-e654d1851256︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/327/tmp_dlwTvb.svg","show":true,"text":null,"uuid":"16ce8065-b6d5-4eff-a8a7-75690fc36327"},"once":false}︡{"done":true}
︠52e0da3e-c342-48fa-a928-8f47cbbed09ds︠
#(b) g1 works well for root1; gprime near the root1 is ?. Let x0=-0.9

def simple_iteration(g,a,n):
    L=[a]
    temp=a
    for j in range(1,n+1):
        temp=g(L[j-1]).n()# Encode the iteration formula here
        L.append(temp)
    return L

simple_it_list1=simple_iteration(g1,-0.9,7);simple_it_list1
︡3416462b-a94e-4a9d-839d-6757712eaff7︡{"stdout":"[-0.900000000000000, -0.156686068051880, -0.224095411245832, -0.230108474460778, -0.230520533881549, -0.230548030998561, -0.230549862530082, -0.230549984509961]\n"}︡{"done":true}
︠e00e5690-d093-4b91-a166-541a011df254s︠
# (c) Plot of f shows that the same initial guess will work for approximating root1 by Newton's method ( since ?>0)
def my_newton(f,a,n):
    L=[a]
    fprime=diff(f,x)
    for j in range(n):
        xold=N(L[j])
        xnew=(L[j-1])-(f(L[j-1])/fprime(L[j-1])) # Encode Newton's formula here
        L.append(xnew)
    return L
︡73d58f34-2080-4685-a64f-c629500c23ad︡{"done":true}
︠9501e13a-c978-470f-a9fb-2c94b108d473s︠
newtons_list1=my_newton(f,-0.9,8);newtons_list1
︡3fe2f55b-fd69-4583-976e-0157e74595ef︡{"stdout":"[-0.900000000000000, -0.532386779451968, -0.532386779451968, -0.313764802062772, -0.313764802062772, -0.238603685771938, -0.238603685771938, -0.230633323982670, -0.230633323982670]\n"}︡{"done":true}
︠5e5f46af-18ed-482f-9d20-0e7ff78c44c1s︠
#(d) Recall that the exact root1 is -0.23054999321338895
nlist=[j for j in range(7)]
table(columns=[nlist,simple_it_list1,newtons_list1],header_row=['n',"Simple iterations", "Newton's iterations"], frame=True)#learn the synatax of this valuable command

︡d1ed9555-ab6b-413b-a812-8e371f616a35︡{"stdout":"+---+--------------------+---------------------+\n| n | Simple iterations  | Newton's iterations |\n+===+====================+=====================+\n| 0 | -0.900000000000000 | -0.900000000000000  |\n+---+--------------------+---------------------+\n| 1 | -0.156686068051880 | -0.532386779451968  |\n+---+--------------------+---------------------+\n| 2 | -0.224095411245832 | -0.532386779451968  |\n+---+--------------------+---------------------+\n| 3 | -0.230108474460778 | -0.313764802062772  |\n+---+--------------------+---------------------+\n| 4 | -0.230520533881549 | -0.313764802062772  |\n+---+--------------------+---------------------+\n| 5 | -0.230548030998561 | -0.238603685771938  |\n+---+--------------------+---------------------+\n| 6 | -0.230549862530082 | -0.238603685771938  |\n+---+--------------------+---------------------+\n"}︡{"done":true}
︠ce282e27-298d-43ab-9205-96372ad2f7a9︠
# Comment: ?.
︡902d9b7d-4de7-46c3-870c-64a1c2dd2157︡
︠09d14d90-6c23-427a-b53b-199d24c3afec︠
###################################
︡ffb91f94-e86c-4cfb-a7dc-79a3182e6f7b︡
︠831df516-138a-4e74-b5cc-ab556b065984s︠
# Version 2: Root 2
# (a)
line_plot2=plot(x,1,2.5)
g2(x)=(5*x+2-exp(x))^0.5
g2plot=plot(g2(x),1,2.5)
g2prime=diff(g2,x)
g2prime_plot=plot(g2prime,1,2.5,color='red')
(g2plot+g2prime_plot+line_plot2).show(figsize=[4,3])
︡756a072f-8df1-4d27-920f-4ee4cc484f0f︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/327/tmp_dhkZk9.svg","show":true,"text":null,"uuid":"d461868e-1674-4688-b5bc-58e9d400b155"},"once":false}︡{"done":true}
︠903264a6-ea0c-4555-b767-9ec80ce9ee11s︠
# (b) g2 works well for root2; there is an interval containing root2 where gprime is ?. Let x0=1.2
simple_it_list2=simple_iteration(g2,1.2,7);simple_it_list2
︡28b62125-5961-41ce-a0d4-67657a323412︡{"stdout":"[1.20000000000000, 2.16330374133256, 2.02896192145109, 2.13040446092206, 2.05760815511591, 2.11206412847833, 2.07244694614844, 2.10190300751602]\n"}︡{"done":true}
︠60522713-a252-4d7d-92bb-239d6a131bc6s︠
# (c)
newtons_list2=my_newton(f,1.2,7);newtons_list2
︡86e97f1b-da06-4178-8194-b17b50103ff7︡{"stdout":"[1.20000000000000, 2.01815229223825, 2.01815229223825, 2.08809908910110, 2.08809908910110, 2.08958417522238, 2.08958417522238, 2.08958484948430]\n"}︡{"done":true}
︠535887d5-c9de-4c0a-a491-e28d21a391b5s︠
#(d) Recal exact root2: 2.0895848494844653
table(columns=[nlist,simple_it_list2,newtons_list2],header_row=['n',"Simple iterations", "Newton's iterations"], frame=True)

###############
#Grading: There are 20 red question marks; correct replacement for each is 0.5 point. There are two brown question marks (theoretical); each replacement 2 points. Total: 12 points.
︡6c211ed8-f3d9-4001-98ff-236c3b49d32e︡{"stdout":"+---+-------------------+---------------------+\n| n | Simple iterations | Newton's iterations |\n+===+===================+=====================+\n| 0 | 1.20000000000000  | 1.20000000000000    |\n+---+-------------------+---------------------+\n| 1 | 2.16330374133256  | 2.01815229223825    |\n+---+-------------------+---------------------+\n| 2 | 2.02896192145109  | 2.01815229223825    |\n+---+-------------------+---------------------+\n| 3 | 2.13040446092206  | 2.08809908910110    |\n+---+-------------------+---------------------+\n| 4 | 2.05760815511591  | 2.08809908910110    |\n+---+-------------------+---------------------+\n| 5 | 2.11206412847833  | 2.08958417522238    |\n+---+-------------------+---------------------+\n| 6 | 2.07244694614844  | 2.08958417522238    |\n+---+-------------------+---------------------+\n"}︡{"done":true}
︠519c0472-7d28-4d53-a744-84261cf30ea6︠









